<template>
  <i-col :lg="lg" :md="md" :sm="sm" :xs="xs" @click.native="onClickAction()">
    <div class="stock-company-card" :style="{ background: cardBackgroundColor }">
      <Row class="stock-code">{{ company['stockCode'] }}</Row>
      <Row class="company-name overflow-dot">{{ company['name'] }}</Row>
      <Row class="stock-info">
        <div :style="{ color: stockTextColor }">
          <template v-if="company['stockData']">
            <!-- <span>{{company['stockData']['date']}} : </span> -->
            <span class="stock-price-info">{{company['stockData']['closingPrice']}}</span>
            <span class="stock-change-ratio"> ( {{company['stockData']['priceChangeValue'].toFixed(3)}} )</span>
          </template>
          <template v-else> --- </template>
        </div>
      </Row>

      <Row class="btn-box">
        <slot></slot>
      </Row>
    </div>
  </i-col>
</template>

<script>
  const emits = {
    onClickEmit() {
      this.$emit('on-click', { companyId: this.company.id });
    }
  };

  const actions = {
    onClickAction() {
      this.onClickEmit();
    }
  };

  export default {
    name: 'StockCompanyCard',
    props: {
      company: { required: true },
      lg: { default: 4 },
      md: { default: 6 },
      sm: { default: 12 },
      xs: { default: 24 },
    },
    computed: {
      cardBackgroundColor() {
        let color = 'rgba(35, 76, 158, 0.5)';
        if (this.company.hasOwnProperty('stockData')) {
          switch (this.company.stockData.priceChangeType) {
            case 'advance':
              color = 'rgba(142, 46, 46, 0.5)';
              break;
            case 'decline':
              color = 'rgba(36, 121, 125, 0.5)';
              break;
          }
        }
        return color;
      },
      stockTextColor() {
        let color = 'rgb(79,197,255)';
        if (this.company.hasOwnProperty('stockData')) {
          switch (this.company.stockData.priceChangeType) {
            case 'advance':
              color = '#ff8888';
              break;
            case 'decline':
              color = 'rgb(70, 255, 204)';
              break;
          }
        }
        return color;
      }
    },
    methods: {
      ...emits,
      ...actions,
    },
  }
</script>

<style lang="scss" scoped>
  .stock-company-card {
    width: calc(100% - 10px);
    height: 135px;
    padding: 5px 10px;
    border-radius: 4px;
    margin: 5px;
    cursor: pointer;
    overflow: hidden;
    &:before {
      position: absolute;
      content: "";
      top: 0;
      left: 0;
      width: calc(100% - 10px);
      height: 135px;
      padding: 5px 10px;
      border-radius: 4px;
      margin: 5px;
      background: url(/images/company-card-background.jpg) 0 0 no-repeat;
      z-index: -1;
    }
    .stock-code {
      height: 30px;
      font-size: 20px;
      font-weight: bolder;
    }
    .company-name {
      height: 30px;
      font-size: 20px;
      font-weight: lighter;
    }
    .stock-info {
      .stock-price-info {
        font-size: 18px;
        font-weight: bolder;
      }
      .stock-change-ratio {
        font-size: 14px;
        font-weight: bolder;
      }
    }
    .btn-box {
      height: 100%;
      line-height: 100%;
      vertical-align: middle;
      position: absolute;
      z-index: 1;
      top: 0;
      right: 10px;
      .card-btn {
        float: right;
        margin: 18px 0;
      }
    }
  }
</style>
